/*============================================================================
//	apci31as.c
//
//	aPCI-P31A
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//==========================================================================*/
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "apci31aw.h"

const TCHAR szTitle[] = _T("Sample");
const TCHAR szP31A[]  = _T("aPCI-P31A");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);

/*============================================================================
//	۸т̊Jn
//===========================================================================*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WORD  wLogSlot;				/* ޲̘_ۯĔԍi[ */
	APCI31ARESOURCE Ri;			/* ؿ */
	DWORD dwDLLVer, dwDriverVer;
	DWORD dwSwVal;				/* ۰ذ̒l */
	BYTE  cbDat;
	BOOL  bResult;				/*  */
	TCHAR szBuf[256];

	/*-------------------------------------------------
	// apci31a.dll ̎gp錾
	//-----------------------------------------------*/
	if (Apci31awDllOpen() == FALSE){
		ErrorMessage(APCI31A_SLOT_AUTO);
		return 1;				/* apci31a.dll ۰ނɎs܂ */
	}
	/*-------------------------------------------------
	// ްޮݔԍ\
	// aPCI-P31A DLL,ײްްޮݔԍ擾
	//-----------------------------------------------*/
	if (Apci31awGetVersion(&dwDLLVer, &dwDriverVer) == FALSE){
		ErrorMessage(APCI31A_SLOT_AUTO);
		return 1;
	}
	_stprintf_s(szBuf, 256, _T("GetVersion\n")
							_T("DLL    Version\t: %08lxh\n")
							_T("Driver Version\t: %08lxh"),
							dwDLLVer,
							dwDriverVer);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// aPCI-P31A̎gp錾
	//-----------------------------------------------*/
	wLogSlot = APCI31A_SLOT_AUTO;			/* gp޲T܂B*/
	bResult = Apci31awCreate(&wLogSlot);	/* ꍇA̎޲̘_ۯĔԍi[܂B*/
	if (bResult == FALSE){					/* ޲܂B*/
		ErrorMessage(APCI31A_SLOT_AUTO);
		return 1;
	}
	_stprintf_s(szBuf, 256, _T("aPCI-P31A Created\n\n")
							_T("LogSlot: %2d"),
							wLogSlot);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// ؿ۰ذ̒l擾
	//-----------------------------------------------*/
	if (Apci31awGetResource(wLogSlot, &Ri) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	if (Apci31awGetSwitchValue(wLogSlot, &dwSwVal) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	_stprintf_s(szBuf, 256, _T("Board Name  \t: %s\n")
							_T("IO Address  \t: %04Xh-%04Xh\n")
							_T("EICR Address\t: %04Xh-%04Xh\n")
							_T("Switch      \t: %02X\n"),
							szP31A,
							Ri.dwIOPortBase[1],
							Ri.dwIOPortBase[1] + Ri.dwIOPortLength[1] - 1,
							Ri.dwIOPortBase[0],
							Ri.dwIOPortBase[0] + Ri.dwIOPortLength[0] - 1,
							dwSwVal);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// Port 1 ɔCӂްo
	//-----------------------------------------------*/
	cbDat = (BYTE)0x55;
	if (Apci31awOutPort(wLogSlot, APCI31A_PORT_1, cbDat) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	_stprintf_s(szBuf, 256, _T("Port 1 փf[^o\n")
							_T("Port 1 Out Data: %02xh"),
							cbDat);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// Port 1 ްǂݍ
	//-----------------------------------------------*/
	cbDat = (BYTE)0x00;
	if (Apci31awInPort(wLogSlot, APCI31A_PORT_1, &cbDat) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	_stprintf_s(szBuf, 256, _T("Port 1 f[^\n")
							_T("Port 1 In Data: %02xh"),
							cbDat);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// aPCI-P31A̎gpJ
	//-----------------------------------------------*/
	if (Apci31awClose(wLogSlot) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	ResultMessage(_T("aPCI-P31A Closed"));
	/*-------------------------------------------------
	// apci31a.dll ̎gpJ
	//-----------------------------------------------*/
	if (Apci31awDllClose() == FALSE){
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;
	}
	return 0;
}
/*============================================================================
// ʂ\
//==========================================================================*/
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}
/*============================================================================
// װүނ\
//==========================================================================*/
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Apci31awGetLastError(wLogSlot);
	TCHAR szBuf[256];

	switch (dwRes){
		case APCI31A_ERR_SYSTEM:
			_stprintf_s(szBuf, 256, _T("System error\n\n")
									_T("Error code: %08lxh"),
									GetLastError());
			break;
		case APCI31A_ERR_WRAPDLL:
			_stprintf_s(szBuf, 256, _T("DLL Load error"));
			break;
		default:
			_stprintf_s(szBuf, 256, _T("aPCI-P31A error\n\n")
									_T("Error code: %08lxh"),
									dwRes);
			break;
	}
	MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
}
